/**
  ******************************************************************************
  * @file           : main.c
  * @author         : SINOMCU-AE
  * @brief          : Main program body
  *    
  *          This file provides example code for Timer3 PWM out and printf by uart,
  * TIM3_CH1(PA6)PWM period 1KHz,CC interrupt enable;Duty adjustment 5%-99%,10ms 1% inc or dec.
  * LED1 Toggle uart send information of running count(redirect printf),defualt period 0.5s.
  * For details, see "readme.txt"    
  *         
  ******************************************************************************
   * @attention 
  *                           DISCLAIMER
  * The present firmware which is for guidance only aims at providing customers
  * with coding information regarding their products in order for them to save
  * time. As a result, SinoMCU shall not be held liable for any direct,indirect
  * or consequential damages with respect to any claims arising from the content 
  * of such firmware and/or the use made by customers of the coding information 
  * contained herein in connection with their products.
  *
  * <h2><center>&copy; Copyright (c) 2021 sinomcu All rights reserved.</center></h2>
  *
  ******************************************************************************
  */  
  
#include "system_define.h"

#define COUNT_PERIOD    500       // unit ms

FlagStatus TIME_CC_TRG_FLAG = RESET;

/**
  * @brief  Main program
  * @param  None
  * @retval None
  */
int main(void) {
  uint32_t count = 0;
  uint8_t TIMER_CC_Count   = 0;
  uint8_t TIMER_PWM_Duty    = TIMER_PWM_DUTY_PER_MIN;
  uint8_t Timer_PWM_Duty_Dir = DUTY_DIR_INC;
    
  //sysclk_init();                  // sysclk 48M,HSI/2 *12;if not call this function,default HSI 8M
  SystemCoreClockUpdate();        // get System Core Clock
    
  sys_tick_init();
  gpio_init();
  timer3_pwm_init();
#if(defined(EN_PRINT_UART) && EN_PRINT_UART)  
  MS32_RCC_SetUSARTClockSource(MS32_RCC_USART1_CLKSOURCE_HSI);  // uart clk HSI 8M  
  usart1_uart_init(115200);
#endif
  LED1_ON(); 
  
  printf("\r\n\r\n*****Timer3 CH1 PWM out Example*****");
  printf("\r\n--Inf:System Core Clock %d Hz.",SystemCoreClock);
    
  Start_User_MS_SF_Timer(COUNT_PERIOD);
  while(1) {
    if(TIME_CC_TRG_FLAG == SET) {                          // Timer CC interrupt
      TIME_CC_TRG_FLAG = RESET;  
      TIMER_CC_Count++;

      if(TIMER_CC_Count == TIMER_DUTY_ADJ_10MS_NUM) {      // adjust duty cycle
        TIMER_CC_Count =0;
        if(TIMER_PWM_Duty >= TIMER_PWM_DUTY_PER_MAX) {     // when duty increase to max,than to decrease
          Timer_PWM_Duty_Dir = DUTY_DIR_DEC;
        }
        if(TIMER_PWM_Duty <= TIMER_PWM_DUTY_PER_MIN) {     // when duty decrease to min,than to increase
          Timer_PWM_Duty_Dir = DUTY_DIR_INC;
        }

        MS32_TIM_OC_SetCompareCH1(TIM3, (MS32_TIM_GetAutoReload(TIM3)+1) * TIMER_PWM_Duty / 100 ); //update duty cycle
        printf("\r\n--Inf:Timer3 CH1 PWM Duty %d",TIMER_PWM_Duty);

        if(Timer_PWM_Duty_Dir == DUTY_DIR_INC) {           // increase duty
          TIMER_PWM_Duty++;
        }
        else {
          TIMER_PWM_Duty--;
        }
      } //if(TIMER_CC_Count == TIMER_DUTY_ADJ_10MS_NUM)
    }    
    
    if(Get_State_User_MS_SF_Timer() == SF_TIMER_OV) {
      Start_User_MS_SF_Timer(COUNT_PERIOD);                // clear soft timer ov
      LED1_TOGGLE();
      count++;
      printf("\r\n--Inf: running count:%d",count);
    }
  }
}

/**
  * @brief  timer3 CC interrupt callback function
  * @param  None
  * @retval None
  */
void Timer3_CC1_Callback(void) {
  TIME_CC_TRG_FLAG = SET;
}

/**
  * @brief  SystemClock_Config HSI/2 to PLL*12 sysclk 48M
  * @param  None
  * @retval None
  */
void sysclk_init(void) {
  MS32_RCC_OscInitTypeDef osc_cfg;
  MS32_RCC_PllInitTypeDef pll_cfg;
  MS32_RCC_ClkInitTypeDef clk_cfg;

  // get and clear reset flag 
  MS32_RCC_GetResetFlag(ENABLE);
  
  // osc config 
  osc_cfg.HSIState = MS32_RCC_HSI_ON;
  osc_cfg.HSEState = MS32_RCC_HSE_OFF;
  osc_cfg.LSIState = MS32_RCC_LSI_OFF;
//  osc_cfg.LSEState = MS32_RCC_LSE_ON_DRV_H;
  MS32_RCC_OscConfig(&osc_cfg);
  
  // pll config 
  pll_cfg.PLLState  = MS32_RCC_PLL_ON;
  pll_cfg.PLLSource = MS32_RCC_PLL_SOURCE_HSI_DIV_2;       // HSI/2 4M
  pll_cfg.PLLMUL    = MS32_RCC_PLL_MUL12;
  pll_cfg.PREDIV    = MS32_RCC_PLL_PREDIV_DIV1;
  MS32_RCC_PllConfig(&pll_cfg);
  
  // sysclk config 
  clk_cfg.SYSCLKSource   = MS32_RCC_SYSCLK_SOURCE_PLL;
  clk_cfg.AHBCLKDivider  = MS32_RCC_SYSCLK_DIV1;
  clk_cfg.APB1CLKDivider = MS32_RCC_HCLK_DIV1;
  MS32_RCC_ClockConfig(&clk_cfg);
}

/******************************** END OF FILE *********************************/
